SystemOrganization addCategory: #'Spec-Bindings'!

Object subclass: #AbstractHolder
	instanceVariableNames: 'classSymbols selectorSymbols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Bindings'!

!AbstractHolder commentStamp: '<historical>' prior: 0!
AbstractHolder is an abstract class which handle two dictionaries: one for classes symbol, and one for selectors symbols.!

!AbstractHolder methodsFor: 'protocol' stamp: ''!
classSymbolFor: aSymbol

	^ classSymbols at: aSymbol! !

!AbstractHolder methodsFor: 'protocol' stamp: ''!
classSymbolFor: aSymbol ifAbsent: aBlock

	^ classSymbols at: aSymbol ifAbsent: aBlock! !

!AbstractHolder methodsFor: 'protocol' stamp: ''!
classSymbolFor: aSymbol is: aClassSymbol

	^ classSymbols at: aSymbol put: aClassSymbol! !

!AbstractHolder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/23/2012 14:55'!
initialize
	"Initialization code for AbstractHolder"

	super initialize.

	classSymbols := self initializeClassesDictionary.
	selectorSymbols := self initializeSelectorsDictionary! !

!AbstractHolder methodsFor: 'initialization' stamp: ''!
initializeClassesDictionary

	^ IdentityDictionary new! !

!AbstractHolder methodsFor: 'initialization' stamp: ''!
initializeSelectorsDictionary

	^ IdentityDictionary new! !

!AbstractHolder methodsFor: 'protocol' stamp: ''!
selectorSymbolFor: aSymbol

	^ selectorSymbols at: aSymbol! !

!AbstractHolder methodsFor: 'protocol' stamp: ''!
selectorSymbolFor: aSymbol ifAbsent: aBlock

	^ selectorSymbols at: aSymbol ifAbsent: aBlock! !

!AbstractHolder methodsFor: 'protocol' stamp: ''!
selectorSymbolFor: aSymbol is: aSelector

	^ selectorSymbols at: aSymbol put: aSelector! !

AbstractHolder subclass: #MorphicBindings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Bindings'!

!MorphicBindings commentStamp: '<historical>' prior: 0!
MorphicBindings is the class holding the bindings between Spec and Morphic!

!MorphicBindings methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 4/24/2012 03:17'!
initializeClassesDictionary

	^ IdentityDictionary new
		at: #List 				put: #PluggableListMorph;
		at: #IconList 			put: #PluggableIconListMorph;
		at: #Text 				put: #PluggableTextMorph;
		at: #Button 			put: #PluggableButtonMorph;
		at: #Panel 				put: #PanelMorph;
		at: #Checkbox 			put: #CheckboxMorph;
		at: #DropList 			put: #DropListMorph;
		at: #TextField 			put: #PluggableTextFieldMorph;
		at: #Label 				put: #LabelMorph;
		at: #MultiColumnList 	put: #PluggableMultiColumnListMorph;
		at: #Tree				put: #PluggableTreeMorph;
		at: #FrameLayout		put: #LayoutFrame;
		yourself! !

!MorphicBindings methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/29/2012 10:26'!
initializeSelectorsDictionary

	^ IdentityDictionary new
		at: #addSplitters	 			put: #yourself;
		at: #add:						put: #addMorph:;
		at: #layout:						put: #layoutFrame:;
		at: #fractions:offsets:			put: #fractions:offsets:;
		at: #useProportionalLayout	put: #changeProportionalLayout;
		at: #vSpaceFill					put: {#vResizing:. #spaceFill};
		at: #hSpaceFill					put: {#hResizing:. #spaceFill};
		at: #vShrinkWrap				put: {#vResizing:. #shrinkWrap};
		at: #hShrinkWrap				put: {#hResizing:. #shrinkWrap};
		at: #vRigid						put: {#vResizing:. #rigid};
		at: #hRigid						put: {#hResizing:. #rigid};
		yourself! !

AbstractHolder subclass: #MorphicBindingsWithSplitters
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Bindings'!

!MorphicBindingsWithSplitters commentStamp: '<historical>' prior: 0!
MorphicBindingsWithSplitters is like MorphicBindings with splitters support in addition!

!MorphicBindingsWithSplitters methodsFor: 'initialization' stamp: ''!
initializeClassesDictionary

	^ IdentityDictionary new
		at: #Panel put: #PanelMorphWithSplitters;
		yourself! !

!MorphicBindingsWithSplitters methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/23/2012 16:58'!
initializeSelectorsDictionary

	^ IdentityDictionary new
		at: #addSplitters	 put: #addPaneSplitters;
		yourself! !
